/* ########## 4.9 Position ########## */

.o-pos__absolute--top,
.o-pos__absolute--right,
.o-pos__absolute--bottom,
.o-pos__absolute--left {
  position: absolute;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
}

.o-pos__fixed--top,
.o-pos__fixed--right,
.o-pos__fixed--bottom,
.o-pos__fixed--left {
  position: fixed;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
}

/* Top,Right,Bottom,Left Position */
$num: 0;
@while $num <= 100 {
  .u-top--#{$num} { top: #{$num}px !important; }
  .u-right--#{$num} { right: #{$num}px !important; }
  .u-bottom--#{$num} { bottom: #{$num}px !important; }
  .u-left--#{$num} { left: #{$num}px !important; }

  .u-top--neg-#{$num} { top: -#{$num}px !important; }
  .u-right--neg-#{$num} { right: -#{$num}px !important; }
  .u-bottom--neg-#{$num} { bottom: -#{$num}px !important; }
  .u-left--neg-#{$num} { left: -#{$num}px !important; }

  .u-pos__auto--#{$num} {
    top: #{$num}px !important;
    right: #{$num}px !important;
    bottom: #{$num}px !important;
    left: #{$num}px !important;
  }

  .u-pos--h-#{$num} {
    left: #{$num}px !important;
    right: #{$num}px !important;
  }

  .u-pos--v-#{$num} {
    top: #{$num}px !important;
    bottom: #{$num}px !important;
  }

  $num: $num + 5;
}

.u-pos--left-100 { left: 100px; }
.u-pos--left-200 { left: 200px; }
.u-pos--left-300 { left: 300px; }
.u-pos--left-400 { left: 400px; }

/* Position */
.o-pos__absolute { position: absolute !important; }
.o-pos__relative { position: relative !important; }
.o-pos__fixed { position: fixed !important; }
.o-pos__static { position: static !important; }

.o-pos__absolute--full {
  position: absolute;
  width: 100%;
  height: 100%;
}

.o-pos__absolute--top { bottom: auto; }
.o-pos__absolute--right { left: auto; }
.o-pos__absolute--bottom { top: auto; }
.o-pos__absolute--left { right: auto; }

.o-pos__fixed--top { bottom: auto; }
.o-pos__fixed--right { left: auto; }
.o-pos__fixed--bottom { top: auto; }
.o-pos__fixed--left { right: auto; }

.o-pos--left-auto { left: auto; }
.o-pos--right-auto { right: auto; }
.o-pos--top-auto { top: auto; }
.o-pos--bottom-auto { bottom: auto; }

.z-index-1   { z-index: 1; }
.z-index-50  { z-index: 50; }
.z-index-100 { z-index: 100; }
.z-index-150 { z-index: 150; }
.z-index-200 { z-index: 200; }

@mixin do-position($viewport) {
  .o-pos-#{$viewport}--absolute { position: absolute; }
  .o-pos-#{$viewport}--relative { position: relative; }
  .o-pos-#{$viewport}--fixed { position: fixed; }
  .o-pos-#{$viewport}--static { position: static; }

  .u-top-#{$viewport}--auto { top: auto; }
  .u-right-#{$viewport}--auto { right: auto; }
  .u-bottom-#{$viewport}--auto { bottom: auto; }
  .u-left-#{$viewport}--auto { left: auto; }

  .u-right-#{$viewport}--20 { right: 20px; }

  // add more properties here if you need something to add
}

.u-top--neg-50 {
  top: -50px !important;
}

.u-top--neg-70 {
  top: -70px !important;
}

@media (min-width: 480px) { @include do-position("xs"); }
@include media-breakpoint-up(sm) { @include do-position("sm"); }
@include media-breakpoint-up(md) { @include do-position("md"); }
@include media-breakpoint-up(lg) { @include do-position("lg"); }
@include media-breakpoint-up(xl) { @include do-position("xl"); }
